"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _immutable = require("immutable");

var _ItemAnalysis = _interopRequireDefault(require("../../../../common/records/ItemAnalysis"));

var standardItemAnalysis = new _ItemAnalysis.default((0, _immutable.fromJS)({
  itemId: '3',
  itemBody: 'This is the item body',
  itemAnalysis: {
    scoreInfo: {
      resultSum: 5,
      resultCount: 1
    },
    unansweredInfo: 1,
    difficultyInfo: {
      responseCount: 5,
      correctAnswerCount: 1
    },
    choiceInfo: [{
      choiceCount: 2,
      id: 'id',
      itemBody: '<p>Item&gt;Body</p>',
      correct: true
    }, {
      choiceCount: 3,
      id: 'not_id',
      itemBody: 'choice Item Body not correct',
      correct: false
    }, {
      choiceCount: 4,
      id: 'not_id_again',
      itemBody: 'choice Item Body not correct still',
      correct: false
    }],
    quintile: [1, 2, 3, 4, 5]
  }
}));
var _default = {
  permutations: [],
  renderProps: function renderProps(props) {
    return {
      componentProps: {
        animateDelay: 0,
        animateDuration: 0,
        expanded: true,
        itemAnalysis: standardItemAnalysis,
        itemId: '3',
        position: 0,
        toggleExpanded: Function.prototype,
        outcomesEndpoint: '',
        outcomesToken: '',
        screenreaderNotification: Function.prototype
      }
    };
  }
};
exports.default = _default;