"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _View = _interopRequireDefault(require("@instructure/ui-layout/lib/components/View"));

var _Alert = _interopRequireDefault(require("@instructure/ui-alerts/lib/components/Alert"));

var _Text = _interopRequireDefault(require("@instructure/ui-elements/lib/components/Text"));

var _lib = _interopRequireDefault(require("@instructure/ui-themeable/lib"));

var _Bank = _interopRequireDefault(require("../../../../../../common/records/Bank"));

var _QuizEntry = _interopRequireDefault(require("../../../../../../common/records/QuizEntry"));

var _theme = _interopRequireDefault(require("./theme"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec,
    _class,
    _class2,
    _temp,
    _default_ar_number = Intl.NumberFormat("ar", { style: "decimal" }).format;

var styles = {
  componentId: 'BXWam',
  template: function template(theme) {
    return "\n\n.quiz-core__QuizEntryBankShow--quizEntryBank {\n  background-color: ".concat(theme.quizEntryBankBackgroundColor || 'inherit', ";\n  border: ").concat(theme.quizEntryBankBorderSize || 'inherit', " dashed ").concat(theme.quizEntryBankBorderColor || 'inherit', ";\n  cursor: pointer;\n  padding: ").concat(theme.quizEntryBankPadding || 'inherit', ";\n  margin-top: ").concat(theme.quizEntryBankTopMargin || 'inherit', ";\n}\n\n.quiz-core__QuizEntryBankShow--quizEntryBankText {\n  text-align: left;\n}\n\n[dir=\"ltr\"] .quiz-core__QuizEntryBankShow--quizEntryBankText {\n  text-align: left;\n}\n\n[dir=\"rtl\"] .quiz-core__QuizEntryBankShow--quizEntryBankText {\n  text-align: left;\n}\n\n.quiz-core__QuizEntryBankShow--alertWrapper {\n  margin-bottom: ").concat(theme.alertWrapperMargin || 'inherit', ";\n}\n");
  },
  'quizEntryBank': 'quiz-core__QuizEntryBankShow--quizEntryBank',
  'quizEntryBankText': 'quiz-core__QuizEntryBankShow--quizEntryBankText',
  'alertWrapper': 'quiz-core__QuizEntryBankShow--alertWrapper'
};
var QuizEntryBank = (_dec = (0, _lib.default)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(QuizEntryBank, _Component);

  function QuizEntryBank() {
    (0, _classCallCheck2.default)(this, QuizEntryBank);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(QuizEntryBank).apply(this, arguments));
  }

  (0, _createClass2.default)(QuizEntryBank, [{
    key: "renderSampleError",
    value: function renderSampleError() {
      var _s, _n;

      return _react.default.createElement("div", {
        className: styles.alertWrapper
      }, _react.default.createElement(_Alert.default, {
        variant: "error"
      }, _react.default.createElement(_Text.default, null, _react.default.createElement("b", null, "\u062A\u0645 \u062A\u062C\u0627\u0648\u0632 \u0627\u0644\u062D\u062F \u0627\u0644\u0623\u0642\u0635\u0649 \u0644\u0639\u062F\u062F \u0623\u0633\u0626\u0644\u0629 \u0627\u0644\u0628\u0646\u0643! "), (_s = this.props.entry.itemEntryCount, _n = +_s, (_n === 1 ? "\u064A\u062D\u062A\u0648\u064A \u0647\u0630\u0627 \u0627\u0644\u0628\u0646\u0643 \u0639\u0644\u0649 1 \u0633\u0624\u0627\u0644." : "\u064A\u062D\u062A\u0648\u064A \u0647\u0630\u0627 \u0627\u0644\u0628\u0646\u0643 \u0639\u0644\u0649 " + _default_ar_number(this.props.entry.itemEntryCount) + " \u0623\u0633\u0626\u0644\u0629.")) + " ")));
    }
  }, {
    key: "renderDeletedError",
    value: function renderDeletedError() {
      return _react.default.createElement("div", {
        className: styles.alertWrapper
      }, _react.default.createElement(_Alert.default, {
        variant: "error"
      }, _react.default.createElement(_Text.default, null, "\u0628\u0646\u0643 \u0627\u0644\u0639\u0646\u0627\u0635\u0631 \u0644\u0645 \u064A\u0639\u062F \u0645\u0648\u062C\u0648\u062F\u064B\u0627!")));
    }
  }, {
    key: "renderErrors",
    value: function renderErrors() {
      var _this$props = this.props,
          entry = _this$props.entry,
          quizEntry = _this$props.quizEntry;

      if (entry.archived) {
        return this.renderDeletedError();
      }

      if (quizEntry.selection === 'rand' && quizEntry.sampleNum > entry.itemEntryCount) {
        return this.renderSampleError();
      }
    }
  }, {
    key: "renderContent",
    value: function renderContent() {
      var _s2, _n2, _s3, _n3;

      var sampleNum = this.props.quizEntry.sampleNum;
      if (!sampleNum) sampleNum = 0;
      return _react.default.createElement("div", {
        className: styles.quizEntryBankText
      }, _react.default.createElement(_Text.default, null, (_s2 = sampleNum, _n2 = +_s2, _n2 === 0 ? " \u062C\u0645\u064A\u0639 \u0627\u0644\u0623\u0633\u0626\u0644\u0629 \u0627\u0644\u0645\u0633\u062A\u062E\u0631\u062C\u0629 \u0645\u0646 \u0627\u0644\u0628\u0646\u0643: " : (_n2 === 1 ? _default_ar_number(sampleNum) + " \u0627\u0644\u0633\u0624\u0627\u0644 \u0627\u0644\u0645\u0633\u062A\u062E\u0631\u062C \u0639\u0634\u0648\u0627\u0626\u064A\u064B\u0627 \u0645\u0646 \u0627\u0644\u0628\u0646\u0643: " : _default_ar_number(sampleNum) + " \u0627\u0644\u0623\u0633\u0626\u0644\u0629 \u0627\u0644\u0645\u0633\u062A\u062E\u0631\u062C\u0629 \u0639\u0634\u0648\u0627\u0626\u064A\u064B\u0627 \u0645\u0646 \u0627\u0644\u0628\u0646\u0643: ")) + " ", _react.default.createElement("b", null, this.props.entry.title), _react.default.createElement("br", null), (_s3 = this.props.quizEntry.pointsPossible, _n3 = +_s3, (_n3 === 1 ? _default_ar_number(this.props.quizEntry.pointsPossible) + " \u0646\u0642\u0637\u0629 \u0644\u0643\u0644 \u0633\u0624\u0627\u0644 " : _default_ar_number(this.props.quizEntry.pointsPossible) + " \u0646\u0642\u0627\u0637 \u0644\u0643\u0644 \u0633\u0624\u0627\u0644 "))));
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("div", {
        className: styles.quizEntryBank
      }, _react.default.createElement(_View.default, {
        size: "medium",
        textAlign: "center",
        margin: "large auto",
        padding: "small"
      }, this.renderErrors(), this.renderContent()));
    }
  }]);
  QuizEntryBank.displayName = "QuizEntryBank";
  return QuizEntryBank;
}(_react.Component), _class2.propTypes = {
  entry: _propTypes.default.instanceOf(_Bank.default).isRequired,
  quizEntry: _propTypes.default.instanceOf(_QuizEntry.default).isRequired
}, _temp)) || _class);
exports.default = QuizEntryBank;