"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _View = _interopRequireDefault(require("@instructure/ui-layout/lib/components/View"));

var _Alert = _interopRequireDefault(require("@instructure/ui-alerts/lib/components/Alert"));

var _Text = _interopRequireDefault(require("@instructure/ui-elements/lib/components/Text"));

var _lib = _interopRequireDefault(require("@instructure/ui-themeable/lib"));

var _Bank = _interopRequireDefault(require("../../../../../../common/records/Bank"));

var _QuizEntry = _interopRequireDefault(require("../../../../../../common/records/QuizEntry"));

var _theme = _interopRequireDefault(require("./theme"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec,
    _class,
    _class2,
    _temp,
    _default_ja_number = Intl.NumberFormat("ja", { style: "decimal" }).format;

var styles = {
  componentId: 'BXWam',
  template: function template(theme) {
    return "\n\n.quiz-core__QuizEntryBankShow--quizEntryBank {\n  background-color: ".concat(theme.quizEntryBankBackgroundColor || 'inherit', ";\n  border: ").concat(theme.quizEntryBankBorderSize || 'inherit', " dashed ").concat(theme.quizEntryBankBorderColor || 'inherit', ";\n  cursor: pointer;\n  padding: ").concat(theme.quizEntryBankPadding || 'inherit', ";\n  margin-top: ").concat(theme.quizEntryBankTopMargin || 'inherit', ";\n}\n\n.quiz-core__QuizEntryBankShow--quizEntryBankText {\n  text-align: left;\n}\n\n[dir=\"ltr\"] .quiz-core__QuizEntryBankShow--quizEntryBankText {\n  text-align: left;\n}\n\n[dir=\"rtl\"] .quiz-core__QuizEntryBankShow--quizEntryBankText {\n  text-align: left;\n}\n\n.quiz-core__QuizEntryBankShow--alertWrapper {\n  margin-bottom: ").concat(theme.alertWrapperMargin || 'inherit', ";\n}\n");
  },
  'quizEntryBank': 'quiz-core__QuizEntryBankShow--quizEntryBank',
  'quizEntryBankText': 'quiz-core__QuizEntryBankShow--quizEntryBankText',
  'alertWrapper': 'quiz-core__QuizEntryBankShow--alertWrapper'
};
var QuizEntryBank = (_dec = (0, _lib.default)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(QuizEntryBank, _Component);

  function QuizEntryBank() {
    (0, _classCallCheck2.default)(this, QuizEntryBank);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(QuizEntryBank).apply(this, arguments));
  }

  (0, _createClass2.default)(QuizEntryBank, [{
    key: "renderSampleError",
    value: function renderSampleError() {
      var _s, _n;

      return _react.default.createElement("div", {
        className: styles.alertWrapper
      }, _react.default.createElement(_Alert.default, {
        variant: "error"
      }, _react.default.createElement(_Text.default, null, _react.default.createElement("b", null, "\u30D0\u30F3\u30AF\u306E\u8CEA\u554F\u306E\u6700\u5927\u6570\u3092\u8D85\u3048\u307E\u3057\u305F\uFF01 "), "\u3053\u306E\u30D0\u30F3\u30AF\u306B\u306F " + _default_ja_number(this.props.entry.itemEntryCount) + " \u8CEA\u554F\u304C\u3042\u308A\u307E\u3059\u3002" + " ")));
    }
  }, {
    key: "renderDeletedError",
    value: function renderDeletedError() {
      return _react.default.createElement("div", {
        className: styles.alertWrapper
      }, _react.default.createElement(_Alert.default, {
        variant: "error"
      }, _react.default.createElement(_Text.default, null, "\u30A2\u30A4\u30C6\u30E0\u30D0\u30F3\u30AF\u306F\u3082\u3046\u5B58\u5728\u3057\u3066\u3044\u307E\u305B\u3093\uFF01")));
    }
  }, {
    key: "renderErrors",
    value: function renderErrors() {
      var _this$props = this.props,
          entry = _this$props.entry,
          quizEntry = _this$props.quizEntry;

      if (entry.archived) {
        return this.renderDeletedError();
      }

      if (quizEntry.selection === 'rand' && quizEntry.sampleNum > entry.itemEntryCount) {
        return this.renderSampleError();
      }
    }
  }, {
    key: "renderContent",
    value: function renderContent() {
      var _s2, _n2, _s3, _n3;

      var sampleNum = this.props.quizEntry.sampleNum;
      if (!sampleNum) sampleNum = 0;
      return _react.default.createElement("div", {
        className: styles.quizEntryBankText
      }, _react.default.createElement(_Text.default, null, (_s2 = sampleNum, _n2 = +_s2, _n2 === 0 ? " \u3059\u3079\u3066\u306E\u8CEA\u554F\u306F\u30D0\u30F3\u30AF\u304B\u3089\u5F15\u304D\u51FA\u3055\u308C\u305F\uFF1A" : (_default_ja_number(sampleNum) + " \u30D0\u30F3\u30AF\u304B\u3089\u30E9\u30F3\u30C0\u30E0\u306B\u5F15\u304D\u51FA\u3055\u308C\u305F\u8CEA\u554F\uFF1A")) + " ", _react.default.createElement("b", null, this.props.entry.title), _react.default.createElement("br", null), _default_ja_number(this.props.quizEntry.pointsPossible) + " \u3064\u306E\u8CEA\u554F\u3054\u3068\u306B\u30DD\u30A4\u30F3\u30C8 "));
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("div", {
        className: styles.quizEntryBank
      }, _react.default.createElement(_View.default, {
        size: "medium",
        textAlign: "center",
        margin: "large auto",
        padding: "small"
      }, this.renderErrors(), this.renderContent()));
    }
  }]);
  QuizEntryBank.displayName = "QuizEntryBank";
  return QuizEntryBank;
}(_react.Component), _class2.propTypes = {
  entry: _propTypes.default.instanceOf(_Bank.default).isRequired,
  quizEntry: _propTypes.default.instanceOf(_QuizEntry.default).isRequired
}, _temp)) || _class);
exports.default = QuizEntryBank;