"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactImmutableProptypes = _interopRequireDefault(require("react-immutable-proptypes"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Alert = _interopRequireDefault(require("@instructure/ui-alerts/lib/components/Alert"));

var _Text = _interopRequireDefault(require("@instructure/ui-elements/lib/components/Text"));

var _View = _interopRequireDefault(require("@instructure/ui-layout/lib/components/View"));

var _PresentationContent = _interopRequireDefault(require("@instructure/ui-a11y/lib/components/PresentationContent"));

var _lib = _interopRequireDefault(require("@instructure/ui-themeable/lib"));

var _RichContentRenderer = _interopRequireDefault(require("@instructure/quiz-rce/lib/components/RichContentRenderer"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _PositionBox = _interopRequireDefault(require("../../positionBox/PositionBox"));

var _constants = require("@instructure/quiz-common/lib/constants");

var _componentForItem = _interopRequireDefault(require("../../../../util/componentForItem"));

var _CustomPropTypes = _interopRequireDefault(require("../../../../util/CustomPropTypes"));

var _keyboardClickable = _interopRequireDefault(require("../../../../util/keyboardClickable"));

var _theme = _interopRequireDefault(require("./theme"));

var _dec,
    _class,
    _class2,
    _temp,
    _default_mi_number = Intl.NumberFormat("mi", { style: "decimal" }).format;

var styles = {
  componentId: 'eIOvL',
  template: function template(theme) {
    return "\n\n.quiz-core__SessionItemResult--sessionItemResult {\n  padding: ".concat(theme.sessionItemResultPadding || 'inherit', ";\n}\n\n.quiz-core__SessionItemResult--topBorder {\n  border-top: solid ").concat(theme.topBorderWidth || 'inherit', " ").concat(theme.topBorderColor || 'inherit', ";\n}\n\n.quiz-core__SessionItemResult--result {\n  margin: ").concat(theme.resultMargin || 'inherit', ";\n}\n\n.quiz-core__SessionItemResult--points {\n  color: ").concat(theme.pointsColor || 'inherit', ";\n  font-size: ").concat(theme.pointFontSize || 'inherit', ";\n}\n\n.quiz-core__SessionItemResult--question {\n  font-size: ").concat(theme.questionFontSize || 'inherit', ";\n}\n\n.quiz-core__SessionItemResult--sessionItemResultHeader {\n  display: flex;\n  align-items: center;\n}\n\n.quiz-core__SessionItemResult--itemFeedbackWrapper {\n  margin-top: ").concat(theme.itemFeedbackWrapperMargin || 'inherit', ";\n  padding: ").concat(theme.itemFeedbackWrapperPadding || 'inherit', ";\n  background-color: ").concat(theme.itemFeedbackWrapperBackgroundColor || 'inherit', ";\n  border-radius: ").concat(theme.itemFeedbackWrapperBorderRadius || 'inherit', ";\n  font-size: ").concat(theme.itemFeedbackWrapperFontSize || 'inherit', ";\n  white-space: pre-wrap;\n}\n\n.quiz-core__SessionItemResult--itemFeedbackLabel {\n  color: ").concat(theme.itemFeedbackLabelColor || 'inherit', ";\n  font-size: ").concat(theme.itemFeedbackLabelFontSize || 'inherit', ";\n  margin-bottom: ").concat(theme.itemFeedbackMargin || 'inherit', ";\n}\n\n.quiz-core__SessionItemResult--itemFeedbackText {\n  margin-top: ").concat(theme.itemFeedbackTextMargin || 'inherit', ";\n}\n");
  },
  'sessionItemResult': 'quiz-core__SessionItemResult--sessionItemResult',
  'topBorder': 'quiz-core__SessionItemResult--topBorder',
  'result': 'quiz-core__SessionItemResult--result',
  'points': 'quiz-core__SessionItemResult--points',
  'question': 'quiz-core__SessionItemResult--question',
  'sessionItemResultHeader': 'quiz-core__SessionItemResult--sessionItemResultHeader',
  'itemFeedbackWrapper': 'quiz-core__SessionItemResult--itemFeedbackWrapper',
  'itemFeedbackLabel': 'quiz-core__SessionItemResult--itemFeedbackLabel',
  'itemFeedbackText': 'quiz-core__SessionItemResult--itemFeedbackText'
};
var SessionItemResult = (_dec = (0, _lib.default)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(SessionItemResult, _Component);

  function SessionItemResult() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, SessionItemResult);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(SessionItemResult)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.getWorkingInstance = function (sessionItemResult) {
      // Check for getWorkingInstance because it does not exist on results page object
      // and is only needed on the grading page
      if (sessionItemResult.getWorkingInstance) {
        return sessionItemResult.getWorkingInstance().toJS();
      }

      return sessionItemResult.toJS();
    };

    return _this;
  }

  (0, _createClass2.default)(SessionItemResult, [{
    key: "position",
    value: function position() {
      return this.props.sessionItem.position;
    }
  }, {
    key: "regraded",
    value: function regraded() {
      return this.props.sessionItemResult.regradeInfo && this.props.sessionItemResult.regradeInfo.get('regraded');
    }
  }, {
    key: "renderAlert",
    value: function renderAlert() {
      return _react.default.createElement(_Alert.default, {
        variant: "warning",
        margin: "medium"
      }, _react.default.createElement(_PresentationContent.default, null, "Kua whakahoutia t\u0113nei p\u0101tai"));
    }
  }, {
    key: "renderRegradePoints",
    value: function renderRegradePoints() {
      var _s, _n, _s2, _n2;

      return _react.default.createElement("div", null, _react.default.createElement(_View.default, {
        as: "span",
        size: "small",
        margin: "small"
      }, _react.default.createElement(_Text.default, {
        color: "secondary"
      }, "Kaute o mua " + (_default_mi_number(this.props.sessionItemResult.regradeInfo.get('originalScore') || 0) + " / " + _default_mi_number(this.props.sessionItemResult.regradeInfo.get('originalPointsPossible')) + " ng\u0101 koinga"))), _react.default.createElement(_View.default, {
        as: "span",
        size: "small",
        margin: "small"
      }, _react.default.createElement(_Text.default, {
        color: "warning"
      }, "Kaute whakahou " + (_default_mi_number(this.props.sessionItemResult.regradeInfo.get('newScore') || 0) + " / " + _default_mi_number(this.props.sessionItemResult.regradeInfo.get('newPointsPossible')) + " ng\u0101 koinga"))));
    }
  }, {
    key: "renderHeader",
    value: function renderHeader() {
      return _react.default.createElement("div", {
        className: styles.sessionItemResultHeader
      }, this.renderResultPosition(), this.regraded() ? this.renderRegradePoints() : this.renderPoints());
    }
  }, {
    key: "renderResultPosition",
    value: function renderResultPosition() {
      var position = this.position();
      var positionText;

      if (this.regraded()) {
        positionText = "Ng\u0101 hua mo t\u016Bemi " + _default_mi_number(position) + ". Kua whakahoutia t\u0113nei p\u0101tai";
      } else {
        positionText = "Ng\u0101 hua mo t\u016Bemi " + _default_mi_number(position) + ".";
      }

      return _react.default.createElement(_PositionBox.default, {
        position: position,
        headingLevel: "h3",
        headingText: positionText
      });
    }
  }, {
    key: "renderPoints",
    value: function renderPoints() {
      return _react.default.createElement("div", {
        className: styles.points
      }, this.pointsDisplayText);
    }
  }, {
    key: "renderFeedbackBox",
    value: function renderFeedbackBox(feedbackContent, formattedFeedbackTitle) {
      if (feedbackContent) {
        return _react.default.createElement("div", {
          className: styles.itemFeedbackWrapper
        }, _react.default.createElement("div", {
          className: styles.itemFeedbackLabel
        }, formattedFeedbackTitle), _react.default.createElement(_RichContentRenderer.default, {
          customStyles: styles.itemFeedbackText,
          content: feedbackContent
        }));
      }
    }
  }, {
    key: "renderItemFeedback",
    value: function renderItemFeedback(simpleSessionItemResult) {
      var itemFeedback = simpleSessionItemResult.feedback && simpleSessionItemResult.feedback.itemFeedback || {};
      var correctFeedback = this.renderFeedbackBox(itemFeedback.correct, "Kupu whakahoki tika");
      var incorrectFeedback = this.renderFeedbackBox(itemFeedback.incorrect, "Kupu whakahoki kaore i te tika");
      var neutralFeedback = this.renderFeedbackBox(itemFeedback.neutral, "Kupu whakahoki wh\u0101nui");

      if (correctFeedback || incorrectFeedback || neutralFeedback) {
        return _react.default.createElement("div", null, correctFeedback, incorrectFeedback, neutralFeedback);
      }
    }
  }, {
    key: "renderGraderFeedback",
    value: function renderGraderFeedback(simpleSessionItemResult) {
      var graderFeedback = simpleSessionItemResult.feedback && simpleSessionItemResult.feedback.graderFeedback || {};

      if (!this.props.hideGraderFeedback && graderFeedback.content) {
        if (this.props.editGraderFeedback) {
          return _react.default.createElement("div", {
            role: "button",
            onClick: this.props.editGraderFeedback,
            onKeyDown: _keyboardClickable.default,
            className: styles.itemFeedbackWrapper,
            tabIndex: "0"
          }, _react.default.createElement("div", {
            className: styles.itemFeedbackLabel
          }, "Kaik\u014Deke Kupu whakahoki"), _react.default.createElement(_RichContentRenderer.default, {
            customStyles: styles.itemFeedbackText,
            content: graderFeedback.content
          }));
        } else {
          return this.renderFeedbackBox(graderFeedback.content, "Kaik\u014Deke Kupu whakahoki");
        }
      }
    }
  }, {
    key: "renderSessionItemResult",
    value: function renderSessionItemResult() {
      var _this$props = this.props,
          appContainer = _this$props.appContainer,
          sessionItem = _this$props.sessionItem,
          sessionItemResult = _this$props.sessionItemResult,
          itemResultsModifications = _this$props.itemResultsModifications;

      if (!sessionItemResult.isLoaded()) {
        return null;
      }

      var item = sessionItem.getItem();
      var slug = item.getInteractionType && item.getInteractionType().slug;
      var ResultInteraction = (0, _componentForItem.default)(slug, _constants.COMPONENT_RESULT);
      var simpleItem = item.toJS();
      var simpleResultsModifications = itemResultsModifications && itemResultsModifications.toJS() || {};
      var simpleSessionItem = sessionItem.toJS();
      var simpleSessionItemResult = sessionItemResult.toJS();
      return _react.default.createElement("div", {
        className: styles.result
      }, _react.default.createElement("div", {
        className: styles.question
      }, _react.default.createElement(ResultInteraction, {
        appContainer: appContainer,
        itemBody: simpleItem.itemBody,
        itemId: simpleSessionItem.id // needed for input group name
        ,
        interactionData: simpleItem.interactionData,
        properties: simpleItem.properties || {},
        scoringData: simpleSessionItem.scoringData,
        scoredData: simpleSessionItemResult.scoredData,
        itemResultsModifications: simpleResultsModifications[simpleSessionItem.id]
      })), this.renderItemFeedback(simpleSessionItemResult), this.renderGraderFeedback(this.getWorkingInstance(sessionItemResult)));
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;

      var classes = (0, _classnames.default)((_classNames = {}, (0, _defineProperty2.default)(_classNames, styles.sessionItemResult, true), (0, _defineProperty2.default)(_classNames, styles.topBorder, this.props.shouldRenderTopBorder), _classNames));
      return _react.default.createElement("div", {
        className: classes
      }, this.regraded() ? this.renderAlert() : null, this.renderHeader(), this.renderSessionItemResult());
    }
  }, {
    key: "points",
    get: function get() {
      var sessionItemResult = this.props.sessionItemResult;
      var normalizedSessionItemResult = sessionItemResult && sessionItemResult.toJS() || {};
      return normalizedSessionItemResult.score;
    }
  }, {
    key: "pointsPresent",
    get: function get() {
      return typeof this.points === 'number';
    }
  }, {
    key: "pointsPossible",
    get: function get() {
      return this.props.sessionItem.pointsPossible;
    }
  }, {
    key: "pointsPossiblePresent",
    get: function get() {
      return typeof this.pointsPossible === 'number';
    }
  }, {
    key: "pointsDisplayText",
    get: function get() {
      var points = this.points;
      var possible = this.pointsPossible;

      if (this.pointsPresent && this.pointsPossiblePresent) {
        var _s3, _n3;

        return _default_mi_number(points) + " / " + _default_mi_number(possible) + " ng\u0101 koinga";
      }

      if (this.pointsPossiblePresent) {
        var _s4, _n4;

        return _default_mi_number(possible) + " ng\u0101 koinga" + " ka taea";
      }

      if (this.pointsPresent) {
        var _s5, _n5;

        return _default_mi_number(points) + " ng\u0101 koinga" + " i whiwhia";
      }

      return '';
    }
  }]);
  SessionItemResult.displayName = "SessionItemResult";
  return SessionItemResult;
}(_react.Component), _class2.propTypes = {
  appContainer: _CustomPropTypes.default.selectors.isRequired,
  editGraderFeedback: _propTypes.default.func,
  hideGraderFeedback: _propTypes.default.bool,
  itemResultsModifications: _reactImmutableProptypes.default.map,
  sessionItem: _reactImmutableProptypes.default.record.isRequired,
  sessionItemResult: _reactImmutableProptypes.default.record.isRequired,
  shouldRenderTopBorder: _propTypes.default.bool
}, _class2.defaultProps = {
  editGraderFeedback: null,
  hideGraderFeedback: false,
  itemResultsModifications: null,
  shouldRenderTopBorder: true
}, _temp)) || _class);
exports.default = SessionItemResult;