"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _View = _interopRequireDefault(require("@instructure/ui-layout/lib/components/View"));

var _Alert = _interopRequireDefault(require("@instructure/ui-alerts/lib/components/Alert"));

var _Text = _interopRequireDefault(require("@instructure/ui-elements/lib/components/Text"));

var _lib = _interopRequireDefault(require("@instructure/ui-themeable/lib"));

var _Bank = _interopRequireDefault(require("../../../../../../common/records/Bank"));

var _QuizEntry = _interopRequireDefault(require("../../../../../../common/records/QuizEntry"));

var _theme = _interopRequireDefault(require("./theme"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec,
    _class,
    _class2,
    _temp,
    _default_ru_number = Intl.NumberFormat("ru", { style: "decimal" }).format;

var styles = {
  componentId: 'BXWam',
  template: function template(theme) {
    return "\n\n.quiz-core__QuizEntryBankShow--quizEntryBank {\n  background-color: ".concat(theme.quizEntryBankBackgroundColor || 'inherit', ";\n  border: ").concat(theme.quizEntryBankBorderSize || 'inherit', " dashed ").concat(theme.quizEntryBankBorderColor || 'inherit', ";\n  cursor: pointer;\n  padding: ").concat(theme.quizEntryBankPadding || 'inherit', ";\n  margin-top: ").concat(theme.quizEntryBankTopMargin || 'inherit', ";\n}\n\n.quiz-core__QuizEntryBankShow--quizEntryBankText {\n  text-align: left;\n}\n\n[dir=\"ltr\"] .quiz-core__QuizEntryBankShow--quizEntryBankText {\n  text-align: left;\n}\n\n[dir=\"rtl\"] .quiz-core__QuizEntryBankShow--quizEntryBankText {\n  text-align: left;\n}\n\n.quiz-core__QuizEntryBankShow--alertWrapper {\n  margin-bottom: ").concat(theme.alertWrapperMargin || 'inherit', ";\n}\n");
  },
  'quizEntryBank': 'quiz-core__QuizEntryBankShow--quizEntryBank',
  'quizEntryBankText': 'quiz-core__QuizEntryBankShow--quizEntryBankText',
  'alertWrapper': 'quiz-core__QuizEntryBankShow--alertWrapper'
};
var QuizEntryBank = (_dec = (0, _lib.default)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(QuizEntryBank, _Component);

  function QuizEntryBank() {
    (0, _classCallCheck2.default)(this, QuizEntryBank);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(QuizEntryBank).apply(this, arguments));
  }

  (0, _createClass2.default)(QuizEntryBank, [{
    key: "renderSampleError",
    value: function renderSampleError() {
      var _s, _n, _v, _i;

      return _react.default.createElement("div", {
        className: styles.alertWrapper
      }, _react.default.createElement(_Alert.default, {
        variant: "error"
      }, _react.default.createElement(_Text.default, null, _react.default.createElement("b", null, "\u041F\u0440\u0435\u0432\u044B\u0448\u0435\u043D\u043E \u043C\u0430\u043A\u0441\u0438\u043C\u0430\u043B\u044C\u043D\u043E\u0435 \u043A\u043E\u043B\u0438\u0447\u0435\u0441\u0442\u0432\u043E \u043F\u0443\u0441\u0442\u044B\u0445 \u043E\u0442\u0432\u0435\u0442\u043E\u0432! "), (_s = this.props.entry.itemEntryCount, _n = +_s, (_v = (_s + '.').split('.')[1].length, _i = Math.floor(Math.abs(+_s)), _v === 0 && _i % 10 === 1 && _i % 100 !== 11 ? "\u042D\u0442\u043E\u0442 \u0431\u0430\u043D\u043A \u0441\u043E\u0434\u0435\u0440\u0436\u0438\u0442 1 \u0432\u043E\u043F\u0440\u043E\u0441." : "\u042D\u0442\u043E\u0442 \u0431\u0430\u043D\u043A \u0441\u043E\u0434\u0435\u0440\u0436\u0438\u0442 " + _default_ru_number(this.props.entry.itemEntryCount) + " \u0432\u043E\u043F\u0440\u043E\u0441\u043E\u0432/\u0432\u043E\u043F\u0440\u043E\u0441\u0430.")) + " ")));
    }
  }, {
    key: "renderDeletedError",
    value: function renderDeletedError() {
      return _react.default.createElement("div", {
        className: styles.alertWrapper
      }, _react.default.createElement(_Alert.default, {
        variant: "error"
      }, _react.default.createElement(_Text.default, null, "\u0411\u0430\u043D\u043A \u044D\u043B\u0435\u043C\u0435\u043D\u0442\u043E\u0432 \u0431\u043E\u043B\u044C\u0448\u0435 \u043D\u0435 \u0441\u0443\u0449\u0435\u0441\u0442\u0432\u0443\u0435\u0442!")));
    }
  }, {
    key: "renderErrors",
    value: function renderErrors() {
      var _this$props = this.props,
          entry = _this$props.entry,
          quizEntry = _this$props.quizEntry;

      if (entry.archived) {
        return this.renderDeletedError();
      }

      if (quizEntry.selection === 'rand' && quizEntry.sampleNum > entry.itemEntryCount) {
        return this.renderSampleError();
      }
    }
  }, {
    key: "renderContent",
    value: function renderContent() {
      var _s2, _n2, _v2, _i2, _s3, _n3, _v3, _i3;

      var sampleNum = this.props.quizEntry.sampleNum;
      if (!sampleNum) sampleNum = 0;
      return _react.default.createElement("div", {
        className: styles.quizEntryBankText
      }, _react.default.createElement(_Text.default, null, (_s2 = sampleNum, _n2 = +_s2, _n2 === 0 ? " \u0412\u0441\u0435 \u0432\u043E\u043F\u0440\u043E\u0441\u044B, \u0438\u0437\u0432\u043B\u0435\u0447\u0435\u043D\u043D\u044B\u0435 \u0438\u0437 \u0431\u0430\u043D\u043A\u0430: " : (_v2 = (_s2 + '.').split('.')[1].length, _i2 = Math.floor(Math.abs(+_s2)), _v2 === 0 && _i2 % 10 === 1 && _i2 % 100 !== 11 ? _default_ru_number(sampleNum) + " \u0432\u043E\u043F\u0440\u043E\u0441, \u0438\u0437\u0432\u043B\u0435\u0447\u0435\u043D\u043D\u044B\u0439 \u0438\u0437 \u0431\u0430\u043D\u043A\u0430 \u0432 \u0441\u043B\u0443\u0447\u0430\u0439\u043D\u043E\u043C \u043F\u043E\u0440\u044F\u0434\u043A\u0435: " : _default_ru_number(sampleNum) + " \u0432\u043E\u043F\u0440\u043E\u0441\u044B, \u0438\u0437\u0432\u043B\u0435\u0447\u0435\u043D\u043D\u044B\u0435 \u0438\u0437 \u0431\u0430\u043D\u043A\u0430 \u0432 \u0441\u043B\u0443\u0447\u0430\u0439\u043D\u043E\u043C \u043F\u043E\u0440\u044F\u0434\u043A\u0435: ")) + " ", _react.default.createElement("b", null, this.props.entry.title), _react.default.createElement("br", null), (_s3 = this.props.quizEntry.pointsPossible, _n3 = +_s3, (_v3 = (_s3 + '.').split('.')[1].length, _i3 = Math.floor(Math.abs(+_s3)), _v3 === 0 && _i3 % 10 === 1 && _i3 % 100 !== 11 ? _default_ru_number(this.props.quizEntry.pointsPossible) + " \u0431\u0430\u043B\u043B \u0437\u0430 \u0432\u043E\u043F\u0440\u043E\u0441 " : _default_ru_number(this.props.quizEntry.pointsPossible) + " \u0431\u0430\u043B\u043B\u043E\u0432 \u0437\u0430 \u0432\u043E\u043F\u0440\u043E\u0441 "))));
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("div", {
        className: styles.quizEntryBank
      }, _react.default.createElement(_View.default, {
        size: "medium",
        textAlign: "center",
        margin: "large auto",
        padding: "small"
      }, this.renderErrors(), this.renderContent()));
    }
  }]);
  QuizEntryBank.displayName = "QuizEntryBank";
  return QuizEntryBank;
}(_react.Component), _class2.propTypes = {
  entry: _propTypes.default.instanceOf(_Bank.default).isRequired,
  quizEntry: _propTypes.default.instanceOf(_QuizEntry.default).isRequired
}, _temp)) || _class);
exports.default = QuizEntryBank;