"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactImmutableProptypes = _interopRequireDefault(require("react-immutable-proptypes"));

var _partial = _interopRequireDefault(require("lodash/partial"));

var _Heading = _interopRequireDefault(require("@instructure/ui-elements/lib/components/Heading"));

var _Link = _interopRequireDefault(require("@instructure/ui-elements/lib/components/Link"));

var _PresentationContent = _interopRequireDefault(require("@instructure/ui-a11y/lib/components/PresentationContent"));

var _Button = _interopRequireDefault(require("@instructure/ui-buttons/lib/components/Button"));

var _Menu = _interopRequireDefault(require("@instructure/ui-menu/lib/components/Menu"));

var _MenuItem = _interopRequireDefault(require("@instructure/ui-menu/lib/components/Menu/MenuItem"));

var _ScreenReaderContent = _interopRequireDefault(require("@instructure/ui-a11y/lib/components/ScreenReaderContent"));

var _Text = _interopRequireDefault(require("@instructure/ui-elements/lib/components/Text"));

var _IconEdit = _interopRequireDefault(require("@instructure/ui-icons/lib/Line/IconEdit"));

var _IconTrash = _interopRequireDefault(require("@instructure/ui-icons/lib/Line/IconTrash"));

var _IconMore = _interopRequireDefault(require("@instructure/ui-icons/lib/Solid/IconMore"));

var _Alert = _interopRequireDefault(require("@instructure/ui-alerts/lib/components/Alert"));

var _List = _interopRequireWildcard(require("@instructure/ui-elements/lib/components/List"));

var _lib = _interopRequireDefault(require("@instructure/ui-themeable/lib"));

var _CustomPropTypes = _interopRequireDefault(require("../../../common/util/CustomPropTypes"));

var _IfFeature = _interopRequireDefault(require("../../../common/components/shared/IfFeature"));

var _EditBankModal = _interopRequireDefault(require("../EditBankModal"));

var _SharingModal = _interopRequireDefault(require("../SharingModal"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _constants = require("@instructure/quiz-common/lib/constants");

var _withI18nSupport2 = _interopRequireDefault(require("@instructure/quiz-common/lib/with-i18n-support"));

var _theme = _interopRequireDefault(require("./theme"));

var _dec,
    _class,
    _class2,
    _temp,
    _default_zhHant_number = Intl.NumberFormat("zh-Hant", { style: "decimal" }).format;

var styles = {
  componentId: 'eShTv',
  template: function template(theme) {
    return "\n\n.quiz-core__BanksList--bankRow {\n  display: flex;\n  flex-direction: row;\n  border-bottom: ".concat(theme.bankRowBorderWidth || 'inherit', " solid ").concat(theme.bankRowBorderColor || 'inherit', ";\n}\n\n.quiz-core__BanksList--bankInfo {\n  margin: ").concat(theme.bankInfoMargin || 'inherit', " 0;\n  flex: 1;\n}\n\n.quiz-core__BanksList--bankTitle {\n  font-size: ").concat(theme.bankTitleFontSize || 'inherit', ";\n  padding-bottom: ").concat(theme.bankTitlePadding || 'inherit', ";\n}\n\n.quiz-core__BanksList--bankDetails {\n  color: ").concat(theme.bankDetailsColor || 'inherit', ";\n  font-size: ").concat(theme.bankDetailsFontSize || 'inherit', ";\n}\n\n.quiz-core__BanksList--bankOptions {\n  margin: ").concat(theme.bankOptionsMargin || 'inherit', " 0;\n}\n\n.quiz-core__BanksList--bankOptionIcon {\n  vertical-align: middle;\n  margin-right: ").concat(theme.BankOptionIconMargin || 'inherit', ";\n  font-size: ").concat(theme.BankOptionIconFontSize || 'inherit', ";\n}\n\n.quiz-core__BanksList--deleteAlert {\n  display: block;\n}\n\n.quiz-core__BanksList--deletePreface {\n  margin-bottom: ").concat(theme.deletePrefaceMargin || 'inherit', ";\n}\n");
  },
  'bankRow': 'quiz-core__BanksList--bankRow',
  'bankInfo': 'quiz-core__BanksList--bankInfo',
  'bankTitle': 'quiz-core__BanksList--bankTitle',
  'bankDetails': 'quiz-core__BanksList--bankDetails',
  'bankOptions': 'quiz-core__BanksList--bankOptions',
  'bankOptionIcon': 'quiz-core__BanksList--bankOptionIcon',
  'deleteAlert': 'quiz-core__BanksList--deleteAlert',
  'deletePreface': 'quiz-core__BanksList--deletePreface'
};
var BanksList = (_dec = (0, _lib.default)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_withI18nSupport) {
  (0, _inherits2.default)(BanksList, _withI18nSupport);

  function BanksList() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, BanksList);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(BanksList)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      sharingModalOpen: false,
      sharingModalBank: null
    };
    _this.sharingButtons = [];

    _this.openModal = function (bank) {
      return function () {
        _this.props.openModal([_constants.EDIT_BANK_MODAL, bank.id].join(':'), {
          modalTrigger: _this.bankActionsButton
        });
      };
    };

    _this.bankActionsButtonRef = function (node) {
      _this.bankActionsButton = node;
    };

    _this.deleteBank = function (bankId) {
      _this.props.deleteBank(bankId);

      setTimeout(_this.props.focusCreateBankButton, 100);
    };

    _this.openDeleteBankModal = function (bankId) {
      return function () {
        var _params, _s;

        var confirmBody = _react.default.createElement(_Alert.default, {
          variant: "error",
          padding: "0"
        }, _react.default.createElement("div", {
          className: styles.deleteAlert
        }, _react.default.createElement("div", {
          className: styles.deletePreface
        }, "\u4E00\u65E6\u522A\u9664\uFF0C\u81EA\u6B64\u984C\u5EAB\u7684\u9805\u76EE\uFF1A"), _react.default.createElement(_List.default, null, _react.default.createElement(_List.ListItem, null, "\u5C07\u4E0D\u53EF\u518D\u4F9B\u76EE\u524D\u6709\u5171\u4EAB\u8A2A\u554F\u6B0A\u9650\u7684\u5176\u4ED6\u4EBA\u7684\u8A2A\u554F"), _react.default.createElement(_List.ListItem, null, (_params = [function (_ref) {
          var children = _ref.children;
          return _react.default.createElement(_Text.default, {
            weight: "bold",
            key: "0"
          }, children);
        }], [(_s = _params["0"], typeof _s === "function" ? _s({
          children: ["\u4E0D\u6703"]
        }) : _s), "\u5F9E\u4EFB\u4F55\u8A55\u4F30\u4E2D\u79FB\u9664"])), _react.default.createElement(_List.ListItem, null, "\u5C07\u5931\u53BB\u5831\u544A\u4E2D\u7684\u7D71\u8A08\u9023\u7D50\uFF08\u5982\u679C\u5B83\u5011\u662F\u8A55\u4F30\u7684\u4E00\u90E8\u5206\uFF09"), _react.default.createElement(_List.ListItem, null, "\u5C07\u4E0D\u518D\u9069\u7528\u65BC\u4EFB\u4F55\u96A8\u6A5F\u905E\u4EA4\u5617\u8A66\u8A55\u4F30/\u6279\u91CF\u63D0\u53D6\u9805\u76EE\uFF08\u79FB\u9664\u63D0\u53D6\u5C07\u89E3\u6C7A\u6B64\u554F\u984C\uFF09"))));

        _this.props.withConfirm((0, _partial.default)(_this.deleteBank, bankId), {
          text: confirmBody,
          title: "\u522A\u9664\u984C\u5EAB",
          continueText: "\u522A\u9664",
          continueVariant: 'danger',
          size: 'medium'
        });
      };
    };

    _this.openSharingModal = function (bank) {
      return function () {
        _this.setState({
          sharingModalOpen: true,
          sharingModalBank: bank
        });
      };
    };

    _this.handleSharingModalDismiss = function () {
      _this.setState({
        sharingModalOpen: false,
        sharingModalBank: null
      });
    };

    _this.handleSharingButtonRef = function (bankId) {
      return function (node) {
        _this.sharingButtons[bankId] = node;
      };
    };

    _this.renderBankInfo = function (bank) {
      var navigateToBank = function navigateToBank(bankId) {
        return function () {
          return _this.props.navigateToBank(bankId);
        };
      };

      return _react.default.createElement("div", {
        className: styles.bankInfo,
        "data-automation": "sdk-bank-info",
        tabIndex: "-1"
      }, _react.default.createElement("div", {
        className: styles.bankTitle
      }, _react.default.createElement(_Link.default, {
        onClick: navigateToBank(bank.id),
        theme: {
          color: _this.theme.bankTitleLinkColor,
          hoverColor: _this.theme.bankTitleLinkHoverColor
        },
        "data-automation": "sdk-banks-list-bank-title-link"
      }, _react.default.createElement(_Heading.default, {
        as: "h2",
        level: "reset",
        "data-automation": "sdk-banks-list-bank-title-heading"
      }, bank.title))), _this.renderDetails(bank));
    };

    _this.renderBankOptions = function (bank) {
      return _react.default.createElement("div", {
        className: styles.bankOptions
      }, _react.default.createElement(_Menu.default, {
        trigger: _react.default.createElement(_Button.default, {
          variant: "icon",
          ref: _this.bankActionsButtonRef,
          "data-automation": "sdk-more-bank-actions-button",
          icon: _IconMore.default
        }, _react.default.createElement(_ScreenReaderContent.default, null, "\u66F4\u591A " + bank.title + " \u7684\u984C\u5EAB\u52D5\u4F5C"))
      }, _react.default.createElement(_MenuItem.default, {
        onSelect: _this.openModal(bank),
        "data-automation": "sdk-edit-bank-menu-item"
      }, _react.default.createElement(_IconEdit.default, {
        className: styles.bankOptionIcon
      }), "\u7DE8\u8F2F"), _react.default.createElement(_MenuItem.default, {
        onSelect: _this.openDeleteBankModal(bank.id),
        "data-automation": "sdk-delete-bank-menu-item"
      }, _react.default.createElement(_IconTrash.default, {
        className: styles.bankOptionIcon
      }), "\u522A\u9664")));
    };

    _this.renderBank = function (bank) {
      return _react.default.createElement("div", {
        key: bank.id,
        className: styles.bankRow,
        "data-automation": "sdk-banks-list-bank-row"
      }, _react.default.createElement(_EditBankModal.default, {
        workingBank: bank.getWorkingInstance()
      }), _this.renderBankInfo(bank), _this.renderBankOptions(bank));
    };

    return _this;
  }

  (0, _createClass2.default)(BanksList, [{
    key: "renderDetails",
    value: function renderDetails(bank) {
      var _s2, _n, _s3, _n2;

      var numStimuli = bank.entryCount - bank.itemEntryCount;
      var separator = ' | ';
      return _react.default.createElement("div", {
        className: styles.bankDetails,
        "data-automation": "sdk-banks-list-bank-details"
      }, _react.default.createElement("div", null, "\u65BC " + this.formatDateMedium(bank.updatedAt()) + " \u5DF2\u66F4\u65B0", _react.default.createElement(_PresentationContent.default, null, separator), _default_zhHant_number(bank.itemEntryCount) + " \u554F\u984C\u7E3D\u8A08", _react.default.createElement(_PresentationContent.default, null, separator), 0 + " \u76F8\u95DC\u806F\n              " + (_default_zhHant_number(numStimuli) + " \u6FC0\u52F5"), _react.default.createElement(_IfFeature.default, {
        name: "item_bank_sharing"
      }, _react.default.createElement(_PresentationContent.default, null, separator)), _react.default.createElement(_IfFeature.default, {
        name: "item_bank_sharing"
      }, _react.default.createElement(_Link.default, {
        "data-automation": "sdk-shared-bank-share-link",
        as: "button",
        onClick: this.openSharingModal(bank),
        ref: this.handleSharingButtonRef(bank.id)
      }, bank.sharedCount > 0 ? "".concat("\u5206\u4EAB", " (").concat(bank.sharedCount, ")") : "+ \u5206\u4EAB"))));
    }
  }, {
    key: "renderSharingModal",
    value: function renderSharingModal() {
      return _react.default.createElement(_SharingModal.default, {
        appContainer: this.props.appContainer,
        bank: this.state.sharingModalBank,
        getUserInfo: this.props.getUserInfo,
        isOpen: this.state.sharingModalOpen,
        minChars: this.props.minChars,
        modalTrigger: this.sharingButtons[this.state.sharingModalBank.id],
        onDismiss: this.handleSharingModalDismiss,
        onShare: this.props.onShare,
        search: this.props.getShareableUsers
      });
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("div", null, this.state.sharingModalBank && this.renderSharingModal(), this.props.banks.toArray().map(this.renderBank));
    }
  }]);
  BanksList.displayName = "BanksList";
  return BanksList;
}((0, _withI18nSupport2.default)(_react.Component)), _class2.propTypes = {
  appContainer: _CustomPropTypes.default.selectors.isRequired,
  banks: _reactImmutableProptypes.default.list.isRequired,
  focusCreateBankButton: _propTypes.default.func.isRequired,
  deleteBank: _propTypes.default.func.isRequired,
  getUserInfo: _propTypes.default.func,
  getShareableUsers: _propTypes.default.func,
  minChars: _propTypes.default.number,
  navigateToBank: _propTypes.default.func.isRequired,
  onShare: _propTypes.default.func,
  openModal: _propTypes.default.func.isRequired,
  withConfirm: _propTypes.default.func.isRequired,
  locale: _propTypes.default.string,
  timezone: _propTypes.default.string
}, _class2.defaultProps = {
  getUserInfo: null,
  getShareableUsers: null,
  minChars: void 0,
  locale: null,
  timezone: null,
  onShare: function onShare() {}
}, _class2.contextTypes = {
  locale: _propTypes.default.string,
  timezone: _propTypes.default.string
}, _temp)) || _class);
exports.default = BanksList;